#version 330

layout(points) in;
layout(triangle_strip) out;
layout(max_vertices = 4) out;

uniform mat4 VP;
uniform vec3 cameraPosition;
uniform float billboardSize;

out vec2 texCoord;

void main() {
	vec3 position = gl_in[0].gl_Position.xyz;
	vec3 cameraDirection = normalize(cameraPosition - position);
	vec3 upVector = vec3(0.0, 1.0, 0.0);
	vec3 rightVector = cross(cameraDirection, upVector)*billboardSize;

	position -= rightVector;
	gl_Position = VP*vec4(position, 1.0);
	texCoord = vec2(0.0, 0.0);
	EmitVertex();

	position.y += billboardSize;
	gl_Position = VP*vec4(position, 1.0);
	texCoord = vec2(0.0, 1.0);
	EmitVertex();

	position.y -= billboardSize;
	position += rightVector;  
	gl_Position = VP*vec4(position, 1.0);
	texCoord = vec2(1.0, 0.0);
	EmitVertex();

	position.y += billboardSize;
	gl_Position = VP*vec4(position, 1.0);
	texCoord = vec2(1.0, 1.0);
	EmitVertex();

	EndPrimitive();
}
