#version 330 core

layout(location = 0) in vec3 vertex;
layout(location = 3) in ivec4 boneIDs;
layout(location = 4) in vec4 weights;

uniform mat4 M;
uniform mat4 depthVP;
uniform mat4 bones[100];

void main() {
	// bone calculations
	mat4 transform = bones[boneIDs[0]]*weights[0];
	transform += bones[boneIDs[1]]*weights[1];
	transform += bones[boneIDs[2]]*weights[2];
	transform += bones[boneIDs[3]]*weights[3];

	vec4 transformedPosition = transform*vec4(vertex, 1.0);
	gl_Position = depthVP*M*transformedPosition;
}
