#version 330 core

layout(location = 0) in vec2 vertexPosition;
layout(location = 1) in vec2 vertexUV;

out vec2 textureCoord;

uniform int width;
uniform int height;

void main() {
	// map position to homogenous space (-1, +1)
	vec2 homogenousPosition = (vertexPosition - vec2(width/2,height/2))/vec2(width/2,height/2);

	// set position and output variable
	gl_Position = vec4(homogenousPosition, 0, 1);
	textureCoord = vertexUV;
}