#version 330 core

uniform mat4 MVP;
uniform mat4 M;
uniform mat4 biasDepthVP;

layout(location = 0) in vec3 vertex;
layout(location = 1) in vec2 vertexTexCoord;
layout(location = 2) in vec3 vertexNormal;
layout(location = 3) in ivec4 boneIDs;
layout(location = 4) in vec4 weights;

out vec3 fragmentVertex;
out vec2 fragmentTexCoord;
out vec3 fragmentNormal;
out vec4 shadowCoord;

void main() {
	fragmentVertex = vertex;
	fragmentTexCoord = vertexTexCoord;
	fragmentNormal = vertexNormal;

	shadowCoord = biasDepthVP*M*vec4(vertex, 1);

	gl_Position = MVP*vec4(vertex, 1);
}
